// MZduino Arduino code part
// 2.10.2011: Slow down just in case
// 29.9.2011: Initial revision

#define SPEED 40 // SPEED microseconds (minimum) between bits
#define CLOCKPIN 13 // Change these for a different pin setup
#define DATAPIN 12

void setup()
{
  pinMode(CLOCKPIN,OUTPUT);
  pinMode(DATAPIN,OUTPUT);

  Serial.begin(57600);
  Serial.print("MZDuino 0.04 at your service!");
}

void loop()
{
  while(Serial.available()>0)
  {
    int c=Serial.read(); // Read two-bit data (data,clock) as bytes from PC
    
    for(int n=0;n<8;n+=2)
    {   
      unsigned long us=micros();
    
      if(c&(2<<n))
        digitalWrite(DATAPIN,HIGH); // First datapin
      else
        digitalWrite(DATAPIN,LOW);
      if(c&(1<<n))
        digitalWrite(CLOCKPIN,HIGH); // And then clock
      else
        digitalWrite(CLOCKPIN,LOW);
      
      while(micros()<us+SPEED) // Delay to let Sharp take its time
        ;
    }
  }
}
