
;	The Sharp part of MZduino file transfer
;	Marq/Fit
;	1.10.2011: Initial version, fixed to accommodate load/start address

	.globl	_main
	.area   CODE (ABS)
	.org 	0xcf00

_main:
;	Run the code (default)
	call	t1
	jp	(hl)

;	Return to the monitor for saving/hacking purposes
	call	t1
	ld	sp,#0x10f0
	jp	0x00ad

;	Handshake
t1:     ld      a,(0xe008)
        and     #6
        jr      nz,t1

t2:     ld      a,(0xe008)
        and     #6
        xor     #4
        jr      nz,t2

t3:     ld      a,(0xe008)
        and     #6
        xor     #6
        jr      nz,t3

	call	getbyte	; Size
	ld	d,c
	call	getbyte
	ld	e,c

	call	getbyte ; Start address
	ld	h,c
	call	getbyte
	ld	l,c
	push	hl

	call	getbyte ; Load address
	ld	h,c
	call	getbyte
	ld	l,c

	xor	a
	ex	af,af'

still:  call    getbyte ; Get the data
        ld      (hl),c
        inc     hl
        dec     de
        ld      a,d
        or      e
        jp      nz,still

	ex	af,af'
	push	af
	call	getbyte
	pop	af
	cp	c
	jp	z,fine  ; Checksum fine
	jp	0x0000  ; Not fine. Reset.

fine:
	pop	hl	; Pop start address
	ret

getbyte:
        ld      b,#4

b1:     ld      a,(0xe008) ; clock = 0
        bit     2,a
        jp      nz,b1
        rra
        rra
        rr      c

b2:     ld      a,(0xe008) ; clock = 1
        bit     2,a
        jp      z,b2
        rra
        rra
        rr      c

        djnz    b1

	ex	af,af'	; Add checksum
	add	a,c
	ex	af,af'
        ret

;	EOF
